/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.51 by adcroft, Wed Dec 3 19:46:10 2003 UTC revision 1.88 by edhill, Tue Jul 20 19:43:45 2004 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                rm -f ./genmake_cy_md
199                (
200                    cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
201                        &&  ./configure > /dev/null 2>&1  \
202                        &&  make > /dev/null 2>&1
203                    if test -x ./makedepend.exe ; then
204                        $LN ./makedepend.exe ./makedepend
205                    fi
206                    ./makedepend ifparser.c > /dev/null 2>&1  \
207                        &&  echo "true"
208                ) > ./genmake_cy_md
209                grep true ./genmake_cy_md > /dev/null 2>&1
210                RETVAL=$?
211                if test "x$RETVAL" = x0 ; then
212                    MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
213                else
214                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
215                fi
216                rm -f ./genmake_cy_md
217            fi
218        fi
219    }
220    
221    
222  # Guess possible config options for this host  # Guess possible config options for this host
223  find_possible_configs()  {  find_possible_configs()  {
224    
225      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
226      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
227      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
228      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
229        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
230        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
231        PLATFORM=$tmp3
232        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
233      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
234      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
235            
# Line 93  find_possible_configs()  { Line 249  find_possible_configs()  {
249          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
250      fi      fi
251    
252      # makedepend is not always available      look_for_makedepend
     if test "x${MAKEDEPEND}" = x ; then  
       which makedepend >& /dev/null  
       RETVAL=$?  
       if test "x${RETVAL}" = x1 ; then  
          echo "    makedepend was not found. Using xmakedpend instead."  
          MAKEDEPEND='$(TOOLSDIR)/xmakedepend'  
       fi  
     fi  
253    
254      # look for possible fortran compilers      # look for possible fortran compilers
255      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
# Line 138  EOF Line 286  EOF
286          echo "   "$p_FC          echo "   "$p_FC
287          if test "x$FC" = x ; then          if test "x$FC" = x ; then
288              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
289                echo "  Setting FORTRAN compiler to: "$FC
290          fi          fi
291      fi      fi
292    
293      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
294          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
295          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
296              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
297              echo "  The options file:  $p_OF"          fi
298              echo "    appears to match so we'll use it."      fi
299              break  #    echo "  The options file:  $p_OF"
300          fi  #    echo "    appears to match so we'll use it."
301      done  #   for i in $p_FC ; do
302    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
303    #if test -r $p_OF ; then
304    #    OPTFILE=$p_OF
305    #    echo "  The options file:  $p_OF"
306    #    echo "    appears to match so we'll use it."
307    #    break
308    #fi
309    #   done
310      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
311          cat 1>&2 <<EOF          cat 1>&2 <<EOF
312    
# Line 208  get_pdepend_list()  { Line 365  get_pdepend_list()  {
365      . ./.pd_tmp      . ./.pd_tmp
366      rm -f ./.pd_tmp      rm -f ./.pd_tmp
367    
368      echo -n "PNAME = "${}      printf "PNAME = "${}
369  }  }
370    
371    
# Line 222  Usage: "$0" [OPTIONS] Line 379  Usage: "$0" [OPTIONS]
379      -help | --help | -h | --h      -help | --help | -h | --h
380            Print this help message and exit.            Print this help message and exit.
381    
382        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
383          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
384              Use "NAME" as the adoptfile.  By default, the file at
385              "tools/adjoint_options/adjoint_default" will be used.
386    
387      -nooptfile | --nooptfile      -nooptfile | --nooptfile
388        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
389        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 246  Usage: "$0" [OPTIONS] Line 408  Usage: "$0" [OPTIONS]
408        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
409            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
410    
411        -makedepend NAME | -md NAME
412          --makedepend=NAME | -md=NAME
413              Use "NAME" for the MAKEDEPEND program.
414    
415      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
416        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
417            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 287  Usage: "$0" [OPTIONS] Line 453  Usage: "$0" [OPTIONS]
453            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
454            is being used.            is being used.
455    
456        -mpi | --mpi
457              Include MPI header files and link to MPI libraries
458        -mpi=PATH | --mpi=PATH
459              Include MPI header files and link to MPI libraries using MPI_ROOT
460              set to PATH. i.e. Include files from $PATH/include, link to libraries
461              from $PATH/lib and use binaries from $PATH/bin.
462    
463        -bash NAME
464              Explicitly specify the Bourne or BASH shell to use
465    
466    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
467    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
468    
# Line 430  EOF Line 606  EOF
606  }  }
607    
608    
609    check_netcdf_libs()  {
610        cat <<EOF > genmake_tnc.for
611          program fgennc
612    #include "netcdf.inc"
613          integer iret, ncid, xid
614          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
615          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
616          iret = nf_def_dim(ncid, 'X', 11, xid)
617          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
618          iret = nf_close(ncid)
619          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
620          end
621    EOF
622        $CPP genmake_tnc.for > genmake_tnc.f  \
623            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
624        RET_COMPILE=$?
625        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
626        RETVAL=$?
627        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
628            HAVE_NETCDF=t
629        else
630            # try again with "-lnetcdf" added to the libs
631            $CPP genmake_tnc.for > genmake_tnc.f  \
632                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
633                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
634            RET_COMPILE=$?
635            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
636            RETVAL=$?
637            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
638                LIBS="$LIBS -lnetcdf"
639                HAVE_NETCDF=t
640            else
641                cat genmake_tnc.log >> genmake_warnings
642            fi
643        fi
644        rm -f genmake_tnc*
645    }
646    
647    
648    
649    ###############################################################################
650    #   Sequential part of script starts here
651    ###############################################################################
652    
653  #  Set defaults here  #  Set defaults here
654  COMMANDL="$0 $@"  COMMANDL="$0 $@"
655    
# Line 438  LN= Line 658  LN=
658  S64=  S64=
659  KPP=  KPP=
660  FC=  FC=
661    CPP=
662  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
663  DEFINES=  DEFINES=
664  PACKAGES=  PACKAGES=
665  ENABLE=  ENABLE=
# Line 456  FOPTIM= Line 676  FOPTIM=
676  CFLAGS=  CFLAGS=
677  KFLAGS1=  KFLAGS1=
678  KFLAGS2=  KFLAGS2=
679    #LDADD=
680  LIBS=  LIBS=
681  KPPFILES=  KPPFILES=
682  NOOPTFILES=  NOOPTFILES=
683  NOOPTFLAGS=  NOOPTFLAGS=
684    MPI=
685    MPIPATH=
686    
687  # DEFINES checked by test compilation  # DEFINES checked by test compilation
688  HAVE_SYSTEM=  HAVE_SYSTEM=
689  HAVE_FDATE=  HAVE_FDATE=
690  FC_NAMEMANGLE=  FC_NAMEMANGLE=
691  HAVE_CLOC=  HAVE_CLOC=
692    HAVE_NETCDF=
693    HAVE_ETIME=
694    
695  MODS=  MODS=
696  TOOLSDIR=  TOOLSDIR=
697  SOURCEDIRS=  SOURCEDIRS=
698  INCLUDEDIRS=  INCLUDEDIRS=
699  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
700    
701    G2ARGS=
702    BASH=
703  PWD=`pwd`  PWD=`pwd`
704  MAKE=make  MAKE=make
705  AWK=awk  AWK=awk
# Line 488  IEEE= Line 715  IEEE=
715  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
716      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
717  fi  fi
718    FS=
719    FS90=
720    
721  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
722  AD_OPTFILE=  AD_OPTFILE=
# Line 505  TAMC_EXTRA= Line 734  TAMC_EXTRA=
734    
735  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
736  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
737  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
738    
739  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
740  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
741  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
742  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
743  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
744  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
745    
746  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
747  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 541  for i in . $MODS ; do Line 770  for i in . $MODS ; do
770          break          break
771      fi      fi
772  done  done
773  echo -n "  getting local config information:  "  printf "  getting local config information:  "
774  if test -e $gm_local ; then  if test -f $gm_local ; then
775      echo "using $gm_local"      echo "using $gm_local"
776      . $gm_local      . $gm_local
777      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 563  fi Line 792  fi
792  #done  #done
793  #parse_options  #parse_options
794  ac_prev=  ac_prev=
795  for ac_option ; do  for ac_option in $@ ; do
796    
797        G2ARGS="$G2ARGS \"$ac_option\""
798    
799      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
800      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 606  for ac_option ; do Line 837  for ac_option ; do
837          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
838              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
839                    
840            -bash | --bash)
841                ac_prev=BASH ;;
842            -bash=* | --bash=*)
843                BASH=$ac_optarg ;;
844            
845            -makedepend | --makedepend | -md | --md)
846                ac_prev=MAKEDEPEND ;;
847            -makedepend=* | --makedepend=* | -md=* | --md=*)
848                MAKEDEPEND=$ac_optarg ;;
849            
850          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
851              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
852          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 653  for ac_option ; do Line 894  for ac_option ; do
894          -fc=* | --fc=*)          -fc=* | --fc=*)
895              FC=$ac_optarg ;;              FC=$ac_optarg ;;
896                    
897            -fs | --fs)
898                ac_prev=FS ;;
899            -fs=* | --fs=*)
900                FS=$ac_optarg ;;
901            
902            -fs90 | --fs90)
903                ac_prev=FS90 ;;
904            -fs90=* | --fs90=*)
905                FS90=$ac_optarg ;;
906            
907          -ieee | --ieee)          -ieee | --ieee)
908              IEEE=true ;;              IEEE=true ;;
909          -noieee | --noieee)          -noieee | --noieee)
910              IEEE= ;;              IEEE= ;;
911    
912            -mpi | --mpi)
913                MPI=true ;;
914            -mpi=* | --mpi=*)
915                MPIPATH=$ac_optarg
916                MPI=true ;;
917                    
918  #       -jam | --jam)  #       -jam | --jam)
919  #           JAM=1 ;;  #           JAM=1 ;;
# Line 703  if test -f ./.genmakerc ; then Line 960  if test -f ./.genmakerc ; then
960  fi  fi
961    
962  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
963      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
964        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
965          ROOTDIR=".."          ROOTDIR=".."
966      else      else
967          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
968              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
969                  ROOTDIR=$d                  ROOTDIR=$d
970                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
971                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
972                  break                  break
973              fi              fi
# Line 743  if test "x$OPTFILE" != xNONE ; then Line 1001  if test "x$OPTFILE" != xNONE ; then
1001          . "$OPTFILE"          . "$OPTFILE"
1002          RETVAL=$?          RETVAL=$?
1003          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1004              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1005              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1006              exit 1              exit 1
1007          fi          fi
# Line 756  if test "x$OPTFILE" != xNONE ; then Line 1014  if test "x$OPTFILE" != xNONE ; then
1014      fi      fi
1015  fi  fi
1016    
1017    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1018    # check_for_broken_Ff
1019    
1020  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1021  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1022      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 770  if test "x${AD_OPTFILE}" != xNONE ; then Line 1031  if test "x${AD_OPTFILE}" != xNONE ; then
1031          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1032          RETVAL=$?          RETVAL=$?
1033          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1034              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1035              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1036              exit 1              exit 1
1037          fi          fi
# Line 785  fi Line 1046  fi
1046    
1047  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1048  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1049    if test ! "x$BASH" = x ; then
1050        # add a trailing space so that it works within the Makefile syntax (see below)
1051        BASH="$BASH "
1052    fi
1053  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1054      cat <<EOF 1>&2      cat <<EOF 1>&2
1055    
# Line 798  fi Line 1063  fi
1063  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1064      LINK=$FC      LINK=$FC
1065  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
1066  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1067      MAKE="make"      MAKE="make"
1068  fi  fi
1069    if test "x$CPP" = x ; then
1070        CPP=cpp
1071    fi
1072    #EH3 === UGLY ===
1073    #  The following is an ugly little hack to check for $CPP in /lib/ and
1074    #  it should eventually be replaced with a more general function that
1075    #  searches a combo of the user's path and a list of "usual suspects"
1076    #  to find the correct location for binaries such as $CPP.
1077    for i in " " "/lib/" ; do
1078        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1079    done
1080    #EH3 === UGLY ===
1081  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1082  RETVAL=$?  RETVAL=$?
1083  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 820  EOF Line 1094  EOF
1094  else  else
1095      rm -f test_cpp      rm -f test_cpp
1096  fi  fi
1097  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1098  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1099      LN="ln -s"      LN="ln -s"
1100  fi  fi
# Line 840  EOF Line 1112  EOF
1112  fi  fi
1113  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1114    
1115    #  Check for broken *.F/*.f handling and fix if possible
1116    check_for_broken_Ff
1117    
1118    if test ! "x$MPI" = x ; then
1119          echo "  Turning on MPI cpp macros"
1120          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1121    fi
1122    
1123  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1124  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1125  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1126        program hello        program hello
1127        call system('echo hi')        call system('echo hi')
# Line 860  else Line 1139  else
1139  fi  fi
1140  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1141    
1142  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1143  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1144        program hello        program hello
1145        CHARACTER(128) string        CHARACTER(128) string
# Line 881  else Line 1160  else
1160  fi  fi
1161  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1162    
1163  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1164    cat > genmake_tcomp.f <<EOF
1165          program hello
1166          REAL*4 ACTUAL, TARRAY(2)
1167          EXTERNAL ETIME
1168          REAL*4 ETIME
1169          actual = etime( tarray )
1170          print *, tarray
1171          end
1172    EOF
1173    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1174    RETVAL=$?
1175    if test "x$RETVAL" = x0 ; then
1176        HAVE_ETIME=t
1177        DEFINES="$DEFINES -DHAVE_ETIME"
1178        echo "yes"
1179    else
1180        HAVE_ETIME=
1181        echo "no"
1182    fi
1183    rm -f genmake_tcomp*
1184    
1185    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1186  check_HAVE_CLOC  check_HAVE_CLOC
1187  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1188      echo "yes"      echo "yes"
1189  else  else
1190      echo "no"      echo "no"
1191  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
1192  rm -f genmake_t*  rm -f genmake_t*
1193    
1194    printf "  Can we create NetCDF-enabled binaries...  "
1195    check_netcdf_libs
1196    if test "x$HAVE_NETCDF" != x ; then
1197        echo "yes"
1198    else
1199        echo "no"
1200    fi
1201    
1202    
1203  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1204  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1205  for d in $MODS ; do  for d in $MODS ; do
1206      if test ! -d $d ; then      if test ! -d $d ; then
1207          echo          echo
1208          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1209          exit 1          exit 1
1210      else      else
1211          echo -n " $d"          printf " $d"
1212          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1213          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1214      fi      fi
# Line 920  if test "x${PLATFORM}" = x ; then Line 1223  if test "x${PLATFORM}" = x ; then
1223  fi  fi
1224    
1225  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1226      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1227        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1228          EXEDIR=../exe          EXEDIR=../exe
1229      else      else
1230          EXEDIR=.          EXEDIR=.
# Line 935  if test "x${TOOLSDIR}" = x ; then Line 1239  if test "x${TOOLSDIR}" = x ; then
1239      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1240  fi  fi
1241  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1242      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1243      exit 1      exit 1
1244  fi  fi
1245  if test "x$S64" = x ; then  if test "x$S64" = x ; then
# Line 956  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1260  if test -r $ROOTDIR"/eesupp/src/Makefile
1260          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1261      else      else
1262          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1263          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1264          exit 1          exit 1
1265      fi      fi
1266  fi  fi
1267    
1268    #same for exch2
1269    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1270        echo "  Making source files in exch2 from  templates"
1271        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1272        RETVAL=$?
1273        if test "x${RETVAL}" = x0 ; then
1274            rm -f make_exch2.errors
1275        else
1276            echo "Error: problem encountered while building source files in exch2:"
1277            cat make_exch2.errors 1>&2
1278            exit 1
1279        fi
1280    fi
1281    
1282  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1283  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1284      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1016  else Line 1334  else
1334          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1335          RETVAL=$?          RETVAL=$?
1336          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1337              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1338              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1339              exit 1              exit 1
1340          fi          fi
# Line 1024  else Line 1342  else
1342              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1343          done          done
1344          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1345          expand_pkg_groups          RET=1
1346            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1347          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1348      fi      fi
1349  fi  fi
1350    
1351  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1352    for i in $PACKAGES ; do
1353        echo $i >> ./.tmp_pack
1354    done
1355    for i in `grep  "-" ./.tmp_pack` ; do
1356        j=`echo $i | sed 's/[-]//'`
1357        DISABLE="$DISABLE $j"
1358    done
1359  pack=  pack=
1360  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1361      addit="t"      addit="t"
# Line 1046  PACKAGES="$pack" Line 1372  PACKAGES="$pack"
1372  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1373  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1374  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1375    # Test if each explicitly referenced package exists
1376  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1377      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1378        if test ! -d "$ROOTDIR/pkg/$j" ; then
1379          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1380          exit 1          exit 1
1381      fi      fi
1382      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1383  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1384  PACKAGES=  PACKAGES=
1385  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1386      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1387  done  done
1388    rm -f ./.tmp_pack
1389  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1390    
1391  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1125  while test "x$ck" != xtt ; do Line 1452  while test "x$ck" != xtt ; do
1452              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1453              exit 1              exit 1
1454          fi          fi
1455          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1456            #i=$(( $i + 1 ))
1457      done      done
1458      ck=$ck"t"      ck=$ck"t"
1459  done  done
# Line 1144  for i in $PACKAGES ; do Line 1472  for i in $PACKAGES ; do
1472      fi      fi
1473  done  done
1474    
1475    #  Build MNC templates and check for ability to build and use NetCDF
1476    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1477    RETVAL=$?
1478    if test "x$RETVAL" = x0 ; then
1479        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1480        RETVAL=$?
1481        if test "x${RETVAL}" = x0 ; then
1482            rm -f make_mnc.errors
1483        else
1484            echo "Error: problem encountered while building source files in pkg/mnc:"
1485            cat make_mnc.errors 1>&2
1486            exit 1
1487        fi
1488        if test "x$HAVE_NETCDF" != xt ; then
1489            cat <<EOF
1490    
1491    WARNING: the "mnc" package has been enabled but tests failed to
1492      compile and/or execute NetCDF applications.  Please check that:
1493    
1494      1) NetCDF is installed for your compiler and
1495      2) the LIBS variable (within the 'optfile") specifies the correct
1496           NetCDF library to link against.
1497      
1498    EOF
1499        fi
1500    fi
1501    
1502  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1503  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
# Line 1178  for i in $PACKAGES ; do Line 1532  for i in $PACKAGES ; do
1532  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1533      case $i in      case $i in
1534          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1535              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1536              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1537              ;;              ;;
1538      esac      esac
1539  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1542  done
1542    
1543  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1544  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1545  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1546      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1547  fi  fi
1548  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1549      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1550      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1551          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1552          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1553          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1554      else              exit 1
1555          SOURCEDIRS="$SOURCEDIRS $adr"          else
1556      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1557      adr="$ROOTDIR/$d/inc"          fi
1558      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1559          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1560          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1561          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1562      else              exit 1
1563          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1564      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1565  done          fi
1566        done
1567    fi
1568    
1569  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1570  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1571  CPP_OPTIONS=  CPP_OPTIONS=
1572    CPP_EEOPTIONS=
1573  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1574    names=`ls -1 "$ROOTDIR/pkg"`
1575  for i in $spaths ; do  for i in $spaths ; do
1576      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1577      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1578          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1579          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1580          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1581            for n in $names ; do
1582                test_for_package_in_cpp_options $CPP_OPTIONS $n
1583            done
1584        fi
1585        try="$i/CPP_EEOPTIONS.h"
1586        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1587            echo "    found CPP_EEOPTIONS=\"$try\""
1588            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1589    #**** not yet enabled ****
1590    #        test_for_mpi_in_cpp_eeoptions $try
1591    #**** not yet enabled ****
1592            CPP_EEOPTIONS="$try"
1593      fi      fi
1594  done  done
1595  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1596      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1597      exit 1      exit 1
1598  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1599    
1600  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1601  #  compiler.  #  compiler.
# Line 1248  for i in $SOURCEDIRS ; do Line 1610  for i in $SOURCEDIRS ; do
1610      done      done
1611  done  done
1612    
1613    
1614  echo  echo
1615  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1616  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1617  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1618      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1619          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1620      fi      fi
1621  done  done
# Line 1264  rm -rf .links.tmp Line 1625  rm -rf .links.tmp
1625  mkdir .links.tmp  mkdir .links.tmp
1626  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1627  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1628  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1629  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1630  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1631  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1632  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1633  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1634  for d in $alldirs ; do  for d in $alldirs ; do
1635      deplist=      deplist=
# Line 1293  for d in $alldirs ; do Line 1654  for d in $alldirs ; do
1654                  case $extn in                  case $extn in
1655                      F)                      F)
1656                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1657                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1658                          ;;                          ;;
1659                      F90)                      F90)
1660                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1661                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1662                          ;;                          ;;
1663                      c)                      c)
1664                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1665                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1666                          ;;                          ;;
1667                      h)                      h)
1668                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1669                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1670                          ;;                          ;;
1671                      flow)                      flow)
1672                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1673                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1674                          ;;                          ;;
1675                  esac                  esac
1676              fi              fi
# Line 1329  echo "" >> f90srclist.inc Line 1690  echo "" >> f90srclist.inc
1690  echo "" >> hlist.inc  echo "" >> hlist.inc
1691  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1692    
1693  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1694      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1695  fi  fi
1696  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1338  echo "#    $MACHINE" >> $MAKEFILE Line 1699  echo "#    $MACHINE" >> $MAKEFILE
1699  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1700  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1701  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1702  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1703  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1704  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1705    
# Line 1347  EXE_FTL=$EXECUTABLE"_ftl" Line 1708  EXE_FTL=$EXECUTABLE"_ftl"
1708  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1709    
1710  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1711    #
1712    # OPTFILE="$OPTFILE"
1713  #  #
1714  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1715  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1746  EXE_SVD     = ${EXE_SVD}
1746  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1747  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1748    
1749    # These files are created by Makefile
1750    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1751    
1752  EOF  EOF
1753    
1754  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1401  FC = ${FC} Line 1767  FC = ${FC}
1767  # Fortran compiler  # Fortran compiler
1768  F90C = ${F90C}  F90C = ${F90C}
1769  # Link editor  # Link editor
1770  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1771    
1772  # Defines for CPP  # Defines for CPP
1773  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1433  cat csrclist.inc      >> $MAKEFILE Line 1799  cat csrclist.inc      >> $MAKEFILE
1799  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1800  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1801  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1802  echo               >> $MAKEFILE  echo >> $MAKEFILE
1803  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1804  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1805  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1806    echo >> $MAKEFILE
1807    echo '.SUFFIXES:' >> $MAKEFILE
1808    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1809  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1810  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1811    
1812  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1813    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1814  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1815  \$(EXECUTABLE): ${PACKAGES_DOT_H} AD_CONFIG.h \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1816          @echo Creating \$@ ...          @echo Creating \$@ ...
1817          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1818  depend:  depend:
1819          @make links          @make links
1820          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1821          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1822            -rm -f makedepend.out
1823    
1824  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1825    
1826  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1827    
# Line 1464  output.txt: \$(EXECUTABLE) Line 1830  output.txt: \$(EXECUTABLE)
1830          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1831    
1832  clean:  clean:
1833          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1834  Clean:  Clean:
1835          @make clean          @make clean
1836          @make cleanlinks          @make cleanlinks
1837          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
1838          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1839  CLEAN:  CLEAN:
1840          @make Clean          @make Clean
1841          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1842          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1843          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1844          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1845    
1846  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1847  makefile:  makefile:
1848          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1849  cleanlinks:  cleanlinks:
1850          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1851    
1852  # Special targets  # Special targets ($SPECIAL_FILES) which are create by make
1853  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1854          @echo Creating \$@ ...          @echo Creating \$@ ...
1855          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1856  AD_CONFIG.h:  AD_CONFIG.h:
1857          @echo Creating \$@ ...          @echo Creating \$@ ...
1858          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1859    FC_NAMEMANGLE.h:
1860            @echo Creating \$@ ...
1861            echo "$FC_NAMEMANGLE" > \$@
1862    
1863    # The normal chain of rules is (  .F - .$FS - .o  )
1864    
1865    %.o : %.F
1866    
1867  # The normal chain of rules is (  .F - .f - .o  )  .F.$FS:
 .F.f:  
1868          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1869  .f.o:  .$FS.o:
1870          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1871  .F90.f90:  .F90.$FS90:
1872          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1873  .f90.o:  .$FS90.o:
1874          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1875  .c.o:  .c.o:
1876          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1877    
1878  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1879  .F.p:  .F.p:
1880          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1881  .p.f:  .p.$FS:
1882          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1883    
1884  #=========================================  #=========================================
# Line 1533  done Line 1905  done
1905    
1906  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1907  echo >> $MAKEFILE  echo >> $MAKEFILE
1908  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1909  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1910  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1911      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1912      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1913  done  done
1914  echo >> $MAKEFILE  echo >> $MAKEFILE
1915  rm -f ad_files  rm -f ad_files
# Line 1550  adtaf: ad_taf_output.f Line 1922  adtaf: ad_taf_output.f
1922  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1923    
1924  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1925          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1926          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1927          -rm -f ad_config.template          -rm -f ad_config.template
1928          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1582  ftltaf: ftl_taf_output.f Line 1954  ftltaf: ftl_taf_output.f
1954  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1955    
1956  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1957          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1958          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1959          -rm -f ftl_config.template          -rm -f ftl_config.template
1960          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1631  for i in $KPPFILES ; do Line 2003  for i in $KPPFILES ; do
2003      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2004          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2005      fi      fi
2006      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2007  done  done
2008    
2009  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1641  for i in $NOOPTFILES ; do Line 2013  for i in $NOOPTFILES ; do
2013      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2014          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2015      fi      fi
2016      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2017      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2018  done  done
2019    
# Line 1655  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2027  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2027  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2028    
2029  # Create special header files  # Create special header files
2030  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2031  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2032      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2033  else  else
2034      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2035      RETVAL=$?      RETVAL=$?
2036      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
2037          rm -f $PACKAGES_DOT_H".tmp"          rm -f $PACKAGES_DOT_H".tmp"
# Line 1669  else Line 2041  else
2041      fi      fi
2042  fi  fi
2043  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2044      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2045  fi  fi
2046    
2047    
2048  #  Write the "state" for future records  #  Write the "state" for future records
2049  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2050      echo -n "" > genmake_state      printf "" > genmake_state
2051      for i in $gm_state ; do      for i in $gm_state ; do
2052          t1="t2=\$$i"          t1="t2=\$$i"
2053          eval $t1          eval $t1

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.88

  ViewVC Help
Powered by ViewVC 1.1.22